---
/** Default layout for rendering posts */
import { getCollection } from 'astro:content';

import type { Props as DefaultProps } from '~/layouts/Default.astro';
import Default from '~/layouts/Default.astro';
import { env } from '~/lib/env';
import { joinPaths } from '~/lib/path';

export type Props = DefaultProps & {};

const { ...rest } = Astro.props;

const currentPath = Astro.url.pathname;

const page = (await getCollection('posts')).filter(result =>
  currentPath.endsWith(`/${result.slug}/`),
)[0];

const postImage = page?.data?.image;
const postDate = page?.data?.date;
const postTitle = page?.data?.title;
---

<Default {...rest}>
  {
    postImage && (
      <div class="overflow-hidden max-h-screen mb-6 rounded-xl">
        <img class="w-full" src={joinPaths(env.BASE_URL, postImage)} />
      </div>
    )
  }
  <div class="prose dark:prose-invert max-w-full">
    {postTitle && <h1 class="mb-1">{postTitle}</h1>}
    {
      postDate && (
        <time datetime={postDate.toISOString()}>
          {postDate.toLocaleString(undefined, {
            weekday: 'long',
            month: 'long',
            day: 'numeric',
            year: 'numeric',
          })}
        </time>
      )
    }
    <slot />
  </div>
</Default>
